/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef TEXTURE_H
#define TEXTURE_H

#include <string>

namespace SharpConstruct
{
	int POTSize( int npot );

	class Texture
	{
	public:
		Texture();
		~Texture();
			
		bool Load( std::string );
		void AutoCorrect();
		void Bind() const;
		unsigned* RawData();
		unsigned* ReadOnlyRawData(); 
		void PutDataBack( unsigned int* d );
		unsigned W() const;
		unsigned H() const;

		std::string Path() const;
	private:
		std::string _path;
		unsigned _glbuffer;
		void* _handle;
	};
}

#endif // TEXTURE_H
