/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef TEXTUREDISPLAY_H
#define TEXTUREDISPLAY_H

#include "Math.h"
#include "Texture.h"

namespace SharpConstruct
{
	namespace Interface
	{
		class TextureDisplay
		{
		public:
			TextureDisplay( const Math::Point2D< int >& link, Math::Size2D< int > s );
			virtual ~TextureDisplay()
			{}
			
			void SetOffset( Math::Point2D< int > o );
			
			bool Visible() const;
			void SetVisible( bool v );

			void SetTexture( Texture& t );
			
			void Draw();
		private:
			bool _visible;
			const Math::Point2D< int >* _loc_link;
			Math::Size2D< int > _size;
			Math::Point2D< int > _offset;
			Texture* _txtr;
		};
	}
}

#endif // TEXTUREDISPLAY_H
