/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef TOOLTIP_H
#define TOOLTIP_H

#include <string>

namespace SharpConstruct
{
	namespace Interface
	{
		class Tooltip
		{
		public:
			Tooltip( const Math::Point2D< int >& l );

			std::string Message() const;
			void SetMessage( std::string m, std::string e = "" );

			void Draw();
		private:
			std::string _message, _extended;
			const Math::Point2D< int >* _loc_link;
		};
	}
}
#endif // TOOLTIP_H
