#include "Mesh.h"

using namespace SharpConstruct;
using SharpConstruct::Optimized::Point3D;
using SharpConstruct::Color;

void Mesh::Optimize( float amt )
{
	#if 0
	const int orig = _polygon_normals.size();
	std::vector< std::map< unsigned, float > > dists(
		_vertex_polygon_indices.size() );
	// Map of dead vertices to the new vertex index
	std::map< unsigned, unsigned > dead_vertices;
	// Set of all polygons to be removed at the end
	std::set< unsigned > dead_polygons;
	
	// Dists has one map for every vertex; the map contains every other vertex
	// the vertex is connected to (key) and the distance between them as the
	// value
	for( unsigned i = 0; i < _vertex_locations.size(); ++i )
	{
		std::set< unsigned > cs = _connected_vertices( i );
		for( std::set< unsigned >::iterator it = cs.begin(); it != cs.end();
			 ++it )
		{
			if( *it < i )
				continue;
			dists[ i ][ *it ] = _vertex_locations[ i ].Distance(
				_vertex_locations[ *it ] );
		}
	}
	//while( (int)_indices.size() / 3 > orig - amt )
	for( unsigned tc = 0; tc < 20; tc++ )
	{
		unsigned p1 = 0, p2 = *_connected_vertices( 0 ).begin();
		float shortest = _vertex_locations[ p1 ].Distance( _vertex_locations[ p2 ] );
		
		// Discover the shortest edge in the model
		for( unsigned i = 1; i < dists.size(); ++i )
		{
			for( std::map< unsigned, float >::iterator it = dists[ i ].begin();
			     it != dists[ i ].end(); ++it )
			{
				if( ( *it ).second < shortest ||
					shortest < std::numeric_limits< float >::epsilon() )
				{
					shortest = ( *it ).second;
					p1 = i;
					p2 = ( *it ).first;
				}
			}
		}
		
		//std::cout << p1 << ", " << p2 << std::endl;
	
		std::map< unsigned, unsigned > cn = _polygons_with_vertices( p1, p2 );
		
		// Polygons that use p2 should use p1 instead
		// Well, yes, but let's wait:
		/*for( unsigned i = 0; i < _vertex_polygon_indices[ p2 ].size(); ++i )
		{
			for( unsigned j = 0; j <= 2; j++ )
			{
				const unsigned p = _vertex_polygon_indices[ p2 ][ i ];
				if( _indices[ p * 3 + j ] == p2 )
					_indices[ p * 3 + j ] = p1;
			}
		}*/
		// So store the remapping:
		dead_vertices[ p2 ] = p1;
		
		// Remove polygons that use both p1 and p2
		// Again, later:
		for( std::map< unsigned, unsigned >::reverse_iterator i = cn.rbegin();
			 i != cn.rend(); ++i )
		{
			/*for( unsigned j = 0; j <= 2; j++ )
			{
				const int ndx = _indices[ ( *i ).first * 3 + j ];
				for( unsigned k = 0; k < _vertex_polygon_indices[ ndx ].size(); k++ )
				{
				*//*	if( _vertex_polygon_indices[ ndx ][ k ] == ( *i ).first )
						_vertex_polygon_indices[ ndx ].erase(
							_vertex_polygon_indices[ ndx ].begin() + k );*//*
				}
			}
			//std::cout << "rm: " << ( *i ).first << std::endl;
			_indices.erase( _indices.begin() + ( *i ).first * 3,
							_indices.begin() + ( *i ).first * 3 + 3 );*/
			// Store it:
			dead_polygons.insert( ( *i ).first );
		}
		
		// p1 = the midpoint of p1 and p2
		_vertex_locations[ p1 ].Midpoint( _vertex_locations[ p1 ], _vertex_locations[ p2 ] );
		
		_vertex_polygon_indices[ p2 ].clear();
		
		dists[ p1 ].clear();
		dists[ p2 ].clear();
		
		//std::cout << p1 << " " << p2 << std::endl;
	}
	for( std::set< unsigned >::iterator i = dead_polygons.begin();
	     i != dead_polygons.end(); i++ )
		_indices.erase( _indices.begin() + ( *i ) * 3,
		                _indices.begin() + ( *i ) * 3 + 3 );
		
	_recalculate_vertex_polygon_indices();
	
	_polygon_normals.resize( _indices.size() / 3 );
	_recalculate_vertex_polygon_indices();
	_recalculate_all_normals();
	
	_change_operation();
	#endif
}

// Meh. This was the attempt at copying to better structures. Didn't work well.
#if 0
struct poly;
struct vertex
{
	vertex( const Point3D& p3d, const Color& col )
	: p( p3d ), c( col )
	{}
	Point3D p;
	Color c;
};
struct edge
{
	edge( vertex* ve1, vertex* ve2 )
	: v1( ve1 ), v2( ve2 )
	{}
	bool operator==( const edge& e ) const
	{
		return ( ( *v1 ).p == ( *e.v1 ).p && ( *v2 ).p == ( *e.v2 ).p ) ||
		       ( ( *v1 ).p == ( *e.v2 ).p && ( *v2 ).p == ( *e.v1 ).p );
	}
	bool operator<( const edge& e ) const
	{
		return ( v1->p.X() + v1->p.Y() * 2 + v1->p.Z() * 4 +
		         v2->p.X() * 8 + v2->p.Y() * 16 + v2->p.Z() ) <
		       ( e.v1->p.X() + e.v1->p.Y() * 2 + e.v1->p.Z() * 4 +
		         e.v2->p.X() * 8 + e.v2->p.Y() * 16 + e.v2->p.Z() );
	}		
	vertex* v1;
	vertex* v2;
	std::set< poly* > polys;
	float len;
};
struct poly
{
	edge* e1;
	edge* e2;
	edge* e3;
};

void pv( vertex& v )
{
	std::cout << "(" << v.p.X() << "," << v.p.Y() << "," << v.p.Z() << ")";
}

void Mesh::Optimize( float amt )
{
	// New storage forms for the mesh data
	std::list< vertex > v;
	std::vector< vertex* > keys;
	std::list< edge > e;
	std::list< poly > p;
	
	// Load and convert the data
	keys.resize( _vertex_locations.size() );
	for( unsigned i = 0; i < _vertex_locations.size(); ++i )
	{
		v.push_back( vertex( _vertex_locations[ i ], _vertex_colors[ i ] ) );
		keys[ i ] = &v.back();
	}
	p.resize( _polygon_normals.size() );
	std::list< poly >::iterator pit = p.begin();
	for( unsigned i = 0; i < _polygon_normals.size(); i++, ++pit )
	{
		e.push_back( edge( keys[ _indices[ i * 3 ] ],
		                   keys[ _indices[ i * 3 + 1 ] ] ) );
		( *pit ).e1 = &e.back();
		e.back().polys.insert( &*pit );
		e.push_back( edge( keys[ _indices[ i * 3 + 1 ] ],
		                   keys[ _indices[ i * 3 + 2 ] ] ) );
		( *pit ).e2 = &e.back();
		e.back().polys.insert( &*pit );
		e.push_back( edge( keys[ _indices[ i * 3 + 2 ] ],
		                   keys[ _indices[ i * 3 ] ] ) );
		( *pit ).e3 = &e.back();
		e.back().polys.insert( &*pit );
	}
	
	/*std::cout << "start" << std::endl;
	float a = 0;
	std::list< edge >::iterator i1, i2;
	for( i1 = e.begin(); i1 != e.end(); ++i1 )
	{
		//i2++;
		for( i2 = i1; i2 != e.end(); ++i2 )
		{
			a++;
		}
	}
	std::cout << a << std::endl;*/
	

	
	std::cout << e.size() << std::endl;
	e.sort();
	std::list< edge >::iterator i1, i2, i3;
	int i = 0;
	for( i1 = e.begin(); i1 != e.end(); ++i1 )
	{
		std::cout << "(" << i << ") " << std::endl;
		i2 = i1;
		i2++;
		if( i2 != e.end() )
		{
			std::cout << " i2!=e" << std::endl;
			int j = 0;
			while( *i1 == *i2 )
			{
				std::cout << i << ": " << j;
				i3 = i2;
				
				++i2;
				for( std::set< poly* >::iterator pi = ( *i3 ).polys.begin();
				     pi != ( *i3 ).polys.end(); ++pi )
				{
					if( *( ( *pi )->e1 ) == *i3 )
						( *pi )->e1 = &*i3;
					else if( *( ( *pi )->e2 ) == *i3 )
						( *pi )->e2 = &*i3;
					else if( *( ( *pi )->e3 ) == *i3 )
						( *pi )->e3 = &*i3;
				}
				
				e.erase( i3 );
				j++;
				std::cout << "inc, size: " << e.size() << std::endl;
				pv( *( ( *i2 ).v1 ) );
			}
		}
		i++;
		std::cout << "size: " << e.size() << std::endl;
	}
	std::cout << e.size() << std::endl;
	
	/*for( std::list< edge >::iterator i1 = e.begin(); i1 != e.end(); ++i1 )
	{
		pv( *( ( *i1 ).v1 ) );
		std::cout << ", ";
		pv( *( ( *i1 ).v2 ) );
		std::cout << std::endl;
	}*/
	
	/*std::cout << e.size() << ", ";
	int i = 0;
	// Remove duplicate edges
	for( std::list< edge >::iterator i1 = e.begin(); i1 != e.end(); ++i1 )
	{
		std::list< edge >::iterator i2;
		//i2++;
		for( i2 = i1; i2 != e.end(); ++i2 )
		{
			i++;
			if( ( *i1 ).v1 == ( *i2 ).v1 && ( *i1 ).v2 == ( *i2 ).v2 ||
				( *i1 ).v1 == ( *i2 ).v2 && ( *i1 ).v2 == ( *i2 ).v1 )
				e.erase( i2 );
		}
	}
	std::cout << e.size() << ": " << i << std::endl;*/
	
	// Return data to normal structures
	_vertex_locations.resize( v.size() );
	_vertex_normals.resize( v.size() );
	_vertex_colors.resize( v.size() );
	_indices.resize( p.size() * 3 );
	_polygon_normals.resize( p.size() );
	
	std::map< vertex*, unsigned > vtoi;
	unsigned ndx = 0;
	for( std::list< vertex >::iterator it = v.begin();
	     it != v.end(); it++, ndx++ )
	{
		vtoi[ &( *it ) ] = ndx;
		_vertex_locations[ ndx ] = ( *it ).p;
	}
	ndx = 0;
	for( std::list< poly >::iterator it = p.begin(); it != p.end(); it++, ndx++ )
	{
		_indices[ ndx * 3 ] = vtoi[ ( *it ).e1->v1 ];
		_indices[ ndx * 3 + 1 ] = vtoi[ ( *it ).e2->v1 ];
		_indices[ ndx * 3 + 2 ] = vtoi[ ( *it ).e3->v1 ];
	}
	
	_recalculate_vertex_polygon_indices();
	_recalculate_all_normals();
	
	// Calculate distances
	
}
#endif
